;NSIS Modern User Interface
;Basic Example Script
;Written by Joost Verburg

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"
  !include "texts.nsh"

;--------------------------------
;General

  ;Name and file
  Name "${PROGRAM_NAME}"
  OutFile "${INSTALLER_PROGRAM_NAME}.exe"

  ;Default installation folder
  InstallDir "$PROGRAMFILES\${PROGRAM_NAME}"
  
  ;Get installation folder from registry if available
;  InstallDirRegKey HKCU "Software\${PROGRAM_NAME}" ""

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING

;--------------------------------
;Pages

;  !insertmacro MUI_PAGE_LICENSE "${NSISDIR}\Docs\Modern UI\License.txt"
  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES

  !define MUI_FINISHPAGE_RUN "$INSTDIR\${PROGRAM_NAME}\${PROGRAM_NAME}.exe"

  !insertmacro MUI_PAGE_FINISH
  
!define MUI_WELCOMEPAGE_TITLE "${MUI_UNWELCOMEPAGE_TITLE}"
!define MUI_WELCOMEPAGE_TEXT "${MUI_UNWELCOMEPAGE_TEXT}"

  !insertmacro MUI_UNPAGE_WELCOME
;  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"
;  !insertmacro MUI_LANGUAGE "Spanish"

;--------------------------------
;Installer Sections

VAR MYINSTDIR


Section "${NAME_REQUIRED}" Spacejunk

  SectionIn RO

  StrCpy $MYINSTDIR "$INSTDIR\${PROGRAM_NAME}"
  SetOutPath "$MYINSTDIR"
  
  ;ADD YOUR OWN FILES HERE...
  !include "files.nsi"
  
  ;Store installation folder
  ;WriteRegStr HKCU "Software\Modern UI Test" "" $INSTDIR
  
  ;Create uninstaller
  WriteUninstaller "$MYINSTDIR\${UNINSTALER_NAME}.exe"

  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PROGRAM_NAME}" "DisplayName" "${PROGRAM_NAME}"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PROGRAM_NAME}" "UninstallString" '"$MYINSTDIR\${UNINSTALER_NAME}.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PROGRAM_NAME}" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PROGRAM_NAME}" "NoRepair" 1

SectionEnd


; Optional section (can be disabled by the user)
Section "${NAME_STARTMENU}" Startmenu
  CreateDirectory "$SMPROGRAMS\${PROGRAM_NAME}"
  CreateShortCut "$SMPROGRAMS\${PROGRAM_NAME}\${UNINSTALER_NAME}.lnk" "$MYINSTDIR\${UNINSTALER_NAME}.exe" "" "$MYINSTDIR\${UNINSTALER_NAME}.exe" 0
  CreateShortCut "$SMPROGRAMS\${PROGRAM_NAME}\${PROGRAM_NAME}.lnk" "$MYINSTDIR\${PROGRAM_NAME}.exe" "" "$MYINSTDIR\${PROGRAM_NAME}.exe" 0
  
SectionEnd

Section "${NAME_DESKTOP}" Desktop
  CreateShortCut "$DESKTOP\${PROGRAM_NAME}.lnk" "$MYINSTDIR\${PROGRAM_NAME}.exe" "" "$MYINSTDIR\${PROGRAM_NAME}.exe" 0
SectionEnd


;--------------------------------
;Descriptions

  ;Language strings
  LangString DESC_Spacejunk ${LANG_SPANISH} "${DESCRIPTION_REQUIRED}"
  LangString DESC_Startmenu ${LANG_SPANISH} "${DESCRIPTION_STARTMENU}"
  LangString DESC_Desktop ${LANG_SPANISH} "${DESCRIPTION_DESKTOP}"


  ;Assign language strings to sections
  !insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
    !insertmacro MUI_DESCRIPTION_TEXT ${Spacejunk} $(DESC_Spacejunk)
    !insertmacro MUI_DESCRIPTION_TEXT ${Startmenu} $(DESC_Startmenu)
    !insertmacro MUI_DESCRIPTION_TEXT ${Desktop} $(DESC_Desktop)
  !insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

!include "FileFunc.nsh"
!insertmacro un.GetParent

Section "Uninstall"

  ;ADD YOUR OWN FILES HERE...

  Delete "$SMPROGRAMS\${PROGRAM_NAME}\${UNINSTALER_NAME}.lnk"
  Delete "$SMPROGRAMS\${PROGRAM_NAME}\${PROGRAM_NAME}.lnk"
  RMDir "$SMPROGRAMS\${PROGRAM_NAME}"
  Delete "$DESKTOP\${PROGRAM_NAME}.lnk"

  RMDir /r "$INSTDIR"

  ${un.GetParent} "$INSTDIR" $R0
  RMDir "$R0"

;  DeleteRegKey /ifempty HKCU "Software\Modern UI Test"

SectionEnd
