/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef BACKGROUND_H
#define BACKGROUND_H

#include <list>
#include <string>
#include <SDL.h>
#include "vector2d.h"

class GameBody;

/**
 * This class is for drawing the background.
 */
class Background {
public:
    std::list<GameBody*> objects;

    Background();

    /**
     * Draws the background.
     * Draws the body on the screen according to a given view trasnformation.
     * @param eyex Horizontal coordinate of the eye.
     * @param eyey Vertical coordinate of the eye.
     * @param theta The angle the viewer is looking at.
     * @param zoom Zoom factor for the view.
     */
    void draw(real zoom,real theta,const Vector2d & eyet);

};

std::list<GameBody*> starlist(std::string group,int x,int y,real zoom);

#endif // BACKGROUND_H
