/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "bar.h"
#include "graphic.h"

#define FUELBARY (175)
#define FUELBARLENGTH (125)
#define FUELBARBOTTOM (FUELBARY+141)
#define FUELBARLEFT (22)
#define FUELBARRIGHT (30)

FuelBar::FuelBar() : fuelbar("fuelbar",false),fuelbarfill("fuelbarfill",false),redalert("redalert",false) {
    oldvalue=0;
}

void FuelBar::draw(real value) {
    UPDATEOFF(fuelbarfill.draw(FUELBARLEFT,FUELBARY+14));
    if (value<0) 
        value=oldvalue;
    if (value) {
        if (oldvalue!=value) {
            int upperlimit=int(FUELBARY+141-value*FUELBARLENGTH);
            if (oldvalue>value) {
                int lowerlimit=int(FUELBARY+141-oldvalue*FUELBARLENGTH);
                SDL_Rect r={FUELBARLEFT,lowerlimit,FUELBARRIGHT-FUELBARLEFT+1,
                            upperlimit-lowerlimit
                           };
                Graphic::updateRect(Graphic::getScreen(),&r);
            }
            oldvalue=value;
            Graphic::drawFilledRect(FUELBARLEFT,FUELBARBOTTOM,FUELBARRIGHT,upperlimit,
                                    SDL_MapRGB(Graphic::getScreen()->format,40,168,55));
        } else
            UPDATEOFF(Graphic::drawFilledRect(FUELBARLEFT,FUELBARBOTTOM,FUELBARRIGHT,int(FUELBARY+141-value*FUELBARLENGTH),
                                              SDL_MapRGB(Graphic::getScreen()->format,40,168,55)));
    }
    UPDATEOFF(fuelbar.draw(0,FUELBARY));
    if (value<0.25) 
        redalert.draw(FUELBARLEFT-2,FUELBARBOTTOM+16);
}
