/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "bodyfactory.h"
#include "starship.h"

using namespace std;

BodyFactory * BodyFactory::miBf=NULL;

BodyFactory::BodyFactory() {};

BodyFactory * BodyFactory::instance() {
    if (miBf) return miBf;
    return miBf=new BodyFactory();
}

GameBody * BodyFactory::create(const std::string & type,const Vector2d pos,const Vector2d vel,real m,real w) {
    GameBody * c;
    if ("starship1"==type) {
        c=new Starship(type,pos,vel,m,w);
        c->cmfColor=SDL_MapRGB(Graphic::getScreen()->format,0,0,255);
        return c;
    } else if (string::npos!=type.find("trash")) {
        GameBody* t=new GameBody(type,pos,vel,m);
        t->w=0.090*(2*rand()/(real)RAND_MAX-1);
        return t;
    } else if (string::npos!=type.find("asteroid")) {
        c=new GameBody(type,pos,vel,m,0.09*(rand()/(real)RAND_MAX),true,true);
        c->setAngle(360.0*rand()/(real)RAND_MAX);
        c->cmfColor=SDL_MapRGB(Graphic::getScreen()->format,100,100,100);
        return c;
    } else {
        c=new GameBody(type,pos,vel,m,w);
        c->cmfColor=SDL_MapRGB(Graphic::getScreen()->format,255,0,0);
        return c;
    }
}
