/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef COLLISIONHANDLER_H
#define COLLISIONHANDLER_H

#include "cworld.h"

class Simulation;
class PhysicBody;

class CollisionHandler : public SimCollisionListener {
private:
    cWorld * w;
    bool _handle_collision(Simulation * sim,PhysicBody * c1,PhysicBody * c2,const Vector2d & normal);
public:
    CollisionHandler(cWorld * w): w(w) {};
    void evtCollision(Simulation * sim,PhysicBody * c1,PhysicBody * c2,const Vector2d & normal);
};

#endif // COLLISIONHANDLER_H
