/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DEBUGMSG_H
#define DEBUGMSG_H
#include <iostream>

typedef enum {ENDL} CHANNELMANIP;

class DBGErrorChannel {
public:
};

class DBGProfileChannel {
public:
};

template <class T>
inline DBGErrorChannel & operator << (DBGErrorChannel & c,T t) {
    std::cerr<<t;
    return c;
}

template <>
inline DBGErrorChannel & operator << <CHANNELMANIP> (DBGErrorChannel & c,CHANNELMANIP t) {
    switch (t) {
    case ENDL:
        std::cerr<<std::endl;
        break;
    default:
        ;
    }
    return c;
}

template <class T>
inline DBGProfileChannel & operator << (DBGProfileChannel & c,T t) {
    std::cerr<<t;
    return c;
}

template <>
inline DBGProfileChannel & operator << <CHANNELMANIP> (DBGProfileChannel & c,CHANNELMANIP t) {
    switch (t) {
    case ENDL:
        std::cerr<<std::endl;
        break;
    default:
        ;
    }
    return c;
}

extern DBGErrorChannel CHERROR;
extern DBGProfileChannel CHPROFILE;


#endif // DEBUGMSG_H
