/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef EVENTLISTENERLIST_H
#define EVENTLISTENERLIST_H

#include <list>
#include "functionexts.h"

template <class Listener>
class EventListenerList {
public:
    typedef typename DeleteIterationContainer<Listener,std::list<std::pair<Listener,bool> > >::erase_iterator_type erase_iterator_type;
    typedef typename DeleteIterationContainer<Listener,std::list<std::pair<Listener,bool> > >::iterator iterator;
public:
    static bool _erase(const std::pair<Listener,bool> & p) {
        return p.second;
    }
    static Listener _data(std::pair<Listener,bool> & p) {
        return p.first;
    }
    std::list<std::pair<Listener,bool> > listeners;
    DeleteIterationContainer<Listener,std::list<std::pair<Listener,bool> > > dic;
public:
    EventListenerList():dic(&listeners,&EventListenerList<Listener>::_erase,&EventListenerList<Listener>::_data) {};
    void addListener(Listener l) {
        listeners.push_front(std::make_pair(l,false));
    };
    void deleteListener(Listener l);
    iterator begin() {
        return dic.begin();
    }
    erase_iterator_type end() {
        return dic.end();
    }
};

template <class Listener>
void EventListenerList<Listener>::deleteListener(Listener l) {
    for (typename std::list<std::pair<Listener,bool> >::iterator i=listeners.begin();
            i!=listeners.end();i++) {
        if (i->first==l) {
            if (dic.isIterating())
                i->second=true;
            else listeners.erase(i);
            break;
        }
    }
};

#endif // EVENTLISTENERLIST_H
