/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef FADE_H
#define FADE_H

#include "SDL.h"
#include "global.h"

class Fade {
public:
    typedef enum {IN,OUT,NONE} FadeMode;
    Fade() : mode(NONE), delta(0) {}
    void setMode(FadeMode fm,int delta);
    FadeMode getMode() {
        return mode;
    }
    bool step();
private:
    FadeMode mode;
    SDL_Color mycolors[256];
    int inittime,delta;

    void dark_fade_end();
    void light_fade_end();
    void fade(float f);
    bool fade_in(int max,int delta);
    bool fade_out(int max,int delta);
};


#endif // FADE_H
