/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "imagescroller.h"
#include "graphic.h"
#include "clipping.h"

ImageScroller::ImageScroller(SDL_Surface * img,const SDL_Rect & window,double vel)
        : img(img), vel(vel), window(window), init(Graphic::ticks()) {
    this->window.x = Graphic::toScreenw(window.x);
    this->window.y = Graphic::toScreenh(window.y);
    this->window.w = Graphic::toScreenw(window.w);
    this->window.h = Graphic::toScreenh(window.h);
};

void ImageScroller::reset() {
    init=Graphic::ticks();
}

void ImageScroller::draw(SDL_Surface * dst,Uint16 x,Uint16 y,bool drawfull) {
    x = Graphic::toScreenx(x);
    y = Graphic::toScreeny(y);
    SDL_Rect r=window; 
    SDL_Rect dstr={x,y,window.w,window.h};
    if (drawfull)
        r.y=0;
    else
        r.y+=Graphic::toScreenh(int(vel*(Graphic::ticks()-init)));
    int tpos=r.y;
    if (clipRectangle(&r,0,0,img->w,img->h)) {
        if (tpos<0)
            dstr.y+=window.h-r.h;
        dstr.h=r.h;
        SDL_BlitSurface(img,&r,dst,&dstr);
    }
};
