/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "mousescroll.h"
#include <math.h>
#include "graphic.h"

void fastenScroll(int delta,double * scrollvel,real dir) {
    if (fabs(*scrollvel)<MEDIUMSCROLLVEL)
        *scrollvel+=dir*LOWINCREASERATE*delta;
    else if (fabs(*scrollvel)<MAXSCROLLVEL)
        *scrollvel+=dir*FASTINCREASERATE*delta;
    else
        *scrollvel=dir*MAXSCROLLVEL;
}

void lowerScroll(int delta,double * scrollvel) {
    double abssv=fabs(*scrollvel);
    if (abssv>MEDIUMSCROLLVEL) {
        if (abssv>FASTDECREASERATE*delta)
            *scrollvel+=-sgn(*scrollvel)*FASTDECREASERATE*delta;
        else
            *scrollvel=MEDIUMSCROLLVEL;
    } else if (abssv>0) {
        if (abssv>LOWDECREASERATE*delta)
            *scrollvel+=-sgn(*scrollvel)*LOWDECREASERATE*delta;
        else
            *scrollvel=0;
    }
}


void MouseScroll::update(Uint16 delta,const Vector2d & scrollDir) {
    if (scrollDir.y!=0)
        fastenScroll(delta,&scrollvel.y,scrollDir.y);
    else lowerScroll(delta,&scrollvel.y);

    if (scrollDir.x!=0)
        fastenScroll(delta,&scrollvel.x,scrollDir.x);
    else lowerScroll(delta,&scrollvel.x);

//    if (mousePosition.y<=0 || mousePosition.y>=Graphic::getScreen()->h-1)
//      fastenScroll(delta,&scrollvel.y,(mousePosition.y<=0)?-1:1);
//    else lowerScroll(delta,&scrollvel.y);
//    if (mousePosition.x<=0 || mousePosition.x>=Graphic::getScreen()->w-1)
//      fastenScroll(delta,&scrollvel.x,(mousePosition.x<=0)?-1:1);
//    else lowerScroll(delta,&scrollvel.x);
}

void MouseScroll::lower(Uint16 delta) {
    lowerScroll(delta,&scrollvel.x);
    lowerScroll(delta,&scrollvel.y);
}
