/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MOUSESCROLL_H
#define MOUSESCROLL_H

#include "vector2d.h"
#include "SDL.h"

#define MEDIUMSCROLLVEL 0.400
#define MAXSCROLLVEL 2.500
#define LOWINCREASERATE 0.0012
#define FASTINCREASERATE 0.002

#define LOWDECREASERATE 0.001
#define FASTDECREASERATE 0.01

#define sgn(x) ((x)>=0?1:-1)

void fastenScroll(int delta,double * scrollvel,real dir);
void lowerScroll(int delta,double * scrollvel);


class MouseScroll {
public:
    Vector2d scrollvel;
    void update(Uint16 delta,const Vector2d & mousePosition);
    void lower(Uint16 delta);
};

#endif // MOUSESCROLL_H
