/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

/** Interface and implementation to read and write runtime configuration data. */

#ifndef READCONFIG_H
#define READCONFIG_H

#include <iosfwd>
#include "runtimeopts.h"
#include <string>

class Config {
public:
    int audiobuffer;
    int musvolume;
    int fxvolume;
    int width;
    int height;
    bool fullscreen;
    std::string language;
    Config();
};

std::ostream & operator << (std::ostream &,const Config &);

void readconfig(const char * file,Config * c);

#endif // READCONFIG_H
