/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SCORELIST_H
#define SCORELIST_H

#include <map>
#include <string>
#include <iosfwd>
#include <functional>

class ScoreList {
private:
typedef std::multimap<int,std::string,std::greater<int> > Map;
typedef Map::const_iterator const_iterator;
Map scores;
public:
typedef Map::iterator iterator;
ScoreList();
~ScoreList();
bool inside(int points);
int size() const;
std::string getNames() const;
std::string getPoints() const;
iterator setScore(const std::string & name,int points);
int position(iterator i);
void setName(const std::string & name,iterator i);
void erase(iterator i);
void erase_last();
friend std::ostream & operator << (std::ostream & o,const ScoreList & w);
friend std::istream & operator >> (std::istream & o,ScoreList & w);
};

std::ostream & operator << (std::ostream & o,const ScoreList & w);
std::istream & operator >> (std::istream & o,ScoreList & w);

#endif // SCORELIST_H
