/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef SOUNDFX_H
#define SOUNDFX_H

#include "resourcemanager.h"
#include <set>

class Soundfx {
    RMSOUNDRef mc;
    static int nextChannel;
    static bool silence;
    static int volume;
public:
    static void setSilence(bool s);
    static bool getSilence();
    static void setOverallVolume(int vol);
    static int getOverallVolume();
    Soundfx(const std::string & name);
    int play(int loops=0);
    void stop(int ch=-1);
    ~Soundfx();
};

#endif //  SOUNDFX_H
