/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

////////////////////////////////////////////////////////////////
//
// trace.h
//
// Copyright given to the public domain
//
////////////////////////////////////////////////////////////////

#ifndef __TRACE_H__
extern int TRACE_FLAG;
#define traceOn() (TRACE_FLAG = 1)
#define traceOff() (TRACE_FLAG = 0)
#ifdef __cplusplus
#include <iostream.h>
#define trace() (cout << (__FILE__) << "@" << (__LINE__) << endl << flush);

#define ctrace()                                                \
{                                                               \
if (TRACE_FLAG)                                                 \
 {                                                              \
(cout << (__FILE__) << "@" << (__LINE__) << endl << flush); \
 }                                                              \
}

#else
#include <stdio.h>
#include <stdlib.h>
#define trace() printf("%s@%d\n", __FILE__, __LINE__), fflush(NULL);

#define ctrace()                                              \
{                                                             \
if (TRACE_FLAG)                                               \
 {                                                            \
   printf("%s@%d\n", __FILE__, __LINE__), fflush(NULL);       \
 }                                                            \
}

#endif

#endif



