/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef ZOOMCONTROL_H
#define ZOOMCONTROL_H

#include "cworld.h"

class ZoomControl {
    cWorld * w;
    Graphic minus,plus;
public:
    enum {Z_IN,Z_OUT,Z_NONE} state;
    ZoomControl(cWorld * w);
    void draw(int x,int y);
    void step(int delta);
    void mousePress(int x,int y,int mx,int my);
    void release();
    void pressIn();
    void pressOut();
    void releaseIn();
    void releaseOut();
};


class Button {
public:
    Button(int x,int y,const std::string & released,const std::string & pressed);
    bool mousePressed(int x,int y,bool left);
    bool mouseReleased(int x,int y,bool left);
    void mouseMotion(int x,int y);
    void draw();
    typedef enum {PRESSED,ACTIVE,RELEASED} STATE;
    void setState(STATE state);
private:
    Graphic released, pressed;
    int btx,bty,btw,bth;
    STATE state;
};

#endif // ZOOMCONTROL_H
