/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "cmask.h"

using namespace std;


Lexer & CMASK_parse(Lexer & p,CMask & m){
  OUTLINE_Polygon * pol;
  PARSEbegin(Lexer,p);
    MANYbegin;
      Circle circ;
      P1(OTULINE_parsePolygon,&pol);
      P1(OUTLINE_parseCircle,&circ);
      m.push_back(make_pair(pol,circ));
      pol=NULL;
    MANYend;
  PARSEend;
  if (pol) delete pol;
  return p;
};

void CMASK_free(CMask * c){
  for(OUTLINE_Polygons::iterator p=c->begin();p!=c->end();p++) delete p->first;
  delete c;
};


/*
//#define XMLATT(at,s) { RT(TOKID,at) CHAR(L'=') PATTTEXT(s)WS }


Parser & parseMaskSVG(list<Poly*> & l,Parser & parser){
  string at,s;
  Poly * p=NULL;
  PARSEbegin(Parser,parser);
    OPT(LS(L"<?xml") MANY(XMLATT(&at,&s)) S(L"?>") OR POK);
    LS(L"<svg") MANY(XMLATT(&at,&s)) LS(L">");
    LS(L"<defs") MANY(XMLATT(&at,&s)) LS(L"/>");
    LS(L"<g") MANY(XMLATT(&at,&s)) LS(L">");
    LS(L"<image") MANY(XMLATT(&at,&s)) LS(L"/>");
    MANYbegin;
      TRY(LS(L"<path"));
      MANYbegin;
	if (at=="d") {
	  XMLATT(&at,&s);
	  istringstream is(s);
	  StreamTokenizer st(s);
	  Lexer lex=&st;
	  PARSEbegin(Lexer,lex);
	    MANYbegin;
  	      LS(L"M");
	      p=new Poly();
	      MANYbegin;
  	        double rx,ry;
		OPTbegin;
		  LS(L"L");LFLOAT(&rx)LS(L",")LFLOAT(&ry);
		  p->push_back(Point(int(rx),int(ry)));
		OR;
		  LS(L"z");
		  l.push_back(p);
                OPTend;
	      MANYend;
	    MANYend;
	  PARSEend;
	} else PERROR;
      MANYend;
      LS(L"/>");
      LS(L"</g>")
    MANYend;
    LS(L"</svg>");
  PARSEend;
  if (p) delete p;
  return p;
};
*/
