/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "testclipsegment.h"
#include "vector2d.h"
#include <assert.h>
#include <iostream>
#include "clipping.h"
#include "SDL.h"

using namespace std;



void  TestClipSegment(){
  int w=100,h=200;
  Vector2d v1,v2;
  //char c;
  //scanf("%c",&c);
  v1=Vector2d(-50,-50);
  v2=Vector2d(50,50);
  clipSegment(w,h,&v1,&v2);
  assert(v1==Vector2d(0,0));
  assert(v2==Vector2d(50,50));

  v1=Vector2d(-100,200);
  v2=Vector2d(150,-50);
  clipSegment(w,h,&v1,&v2);
  assert(v1==Vector2d(0,100));
  assert(v2==Vector2d(99,1));

  v1=Vector2d(200,200);
  v2=Vector2d(-50,-50);
  clipSegment(w,h,&v1,&v2);
  assert(v1==Vector2d(99,99));
  assert(v2==Vector2d(0,0));

  v1=Vector2d(50,-50);
  v2=Vector2d(50,50);
  clipSegment(w,h,&v1,&v2);
  assert(v1==Vector2d(50,0));
  assert(v2==Vector2d(50,50));

  v1=Vector2d(50,-50);
  v2=Vector2d(50,250);
  clipSegment(w,h,&v1,&v2);
  assert(v1==Vector2d(50,0));
  assert(v2==Vector2d(50,199));

  SDL_Rect r1={0,0,10,10};
  SDL_Rect r2={5,5,5,5};
  addRect(&r1,r2);
  assert(r1.x==0);
  assert(r1.y==0);
  assert(r1.w==10);
  assert(r1.h==10);

  r2.w=10;
  r2.h=10;
  addRect(&r1,r2);
  assert(r1.x==0);
  assert(r1.y==0);
  assert(r1.w==15);
  assert(r1.h==15);

  r1.x=0;
  r1.y=0;
  r1.w=10;
  r1.h=10;
  r2.x=-5;
  r2.y=-5;
  r2.w=10;
  r2.h=10;
  addRect(&r1,r2);
  assert(r1.x==-5);
  assert(r1.y==-5);
  assert(r1.w==15);
  assert(r1.h==15);
}
