/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "testfilteriterator.h"
#include "functionexts.h"
#include <assert.h>
#include <vector>

using namespace std;

bool notIsNull(int *& i){
  return NULL!=i;
}

void FilterIteratorTest(){
  vector<int*> v(5);
  int i=2;
  v.push_back(NULL);
  v.push_back(&i);
  v.push_back(NULL);
  v.push_back(&i);
  v.push_back(NULL);
  filter_iterator<vector<int*>::iterator > it=filter_it(v.begin(),v.end(),&notIsNull);
  int count=0;
  for(;it!=v.end();it++) {
    count++;
    assert(*it!=NULL);
  }
  assert(it==v.end());
  assert(count==2);
  v.clear();
  
  v.push_back(NULL);
  v.push_back(&i);
  it=filter_it<vector<int*>::iterator >(v.begin(),v.end(),&notIsNull);
  count=0;
  for(;it!=v.end();it++) {
    count++;
    assert(*it!=NULL);
  }
  assert(it==v.end());
  assert(count==1);
};
