/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "testreference.h"
#include "reference.h"
#include <assert.h>

class OwnRefT {
 public:
 int i;
 OwnRefT(int i) : i(i) { counter++; }
 OwnRefT * clone() { return new OwnRefT(*this); }
 ~OwnRefT() { counter--; }
 operator int () { return i;}
 static int counter;
};
int OwnRefT::counter=0;

OwnRefT * _clone(OwnRefT * g) { return g ? g->clone() : NULL; }

void OwnRefTest(){
  OwnRef<OwnRefT,_clone> r1=new OwnRefT(2);
  assert(*r1==2);
  // Copy constructor
  OwnRef<OwnRefT,_clone> r2=r1;
  assert(&*r1!=&*r2);
  assert(*r1==*r2);
  assert(*r1==2);
  // assingment
  OwnRef<OwnRefT,_clone> r3;
  r3=r1;
  assert(&*r1!=&*r3);
  assert(*r1==*r3);
  assert(*r1==2);
  // auto assingment
  OwnRefT * temp=&*r3;
  r3=r3;
  assert(temp==&*r3);
  assert(OwnRefT::counter==1);
};
