/*
  Copyright (C) 2009 Facundo Domínguez 

  This file is part of Spacejunk.

  Spacejunk is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Foobar is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "testuta.h"
#include "gem-uta.h"
#include "assert.h"

#define UPDW 640
#define UPDH 480

void TestUta(){
  GemUta * uta = gem_uta_new_coords (0, 0, UPDW, UPDH);
  SDL_Rect r={50,50,100,100};
  GemRect grect={r.x,r.x + r.w - 1,r.y,r.y + r.h - 1};

  gem_uta_add_rect (uta, &grect);
  int num_rects;
  SDL_Rect *rects = gem_uta_get_rects (uta, &num_rects, 0, 0, UPDW, UPDH);
  assert(num_rects==1 && rects[0].x==r.x && rects[0].y==r.y 
	 && rects[0].w==r.w && rects[0].h==r.h);
  free(rects);

  gem_uta_clear (uta);

  gem_uta_add_rect (uta, &grect);
  rects = gem_uta_get_rects (uta, &num_rects, 0, 0, UPDW, UPDH);
  assert(num_rects==1 && rects[0].x==r.x && rects[0].y==r.y 
	 && rects[0].w==r.w && rects[0].h==r.h);
  free(rects);
  
  gem_uta_free(uta);
};
